final/final/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth.views import LoginView as login
from django.conf.urls.static import static
from django.conf import settings


urlpatterns = [
    path('admin', admin.site.urls),
    path('', include('miscosas.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

final/miscosas/urls.py
from . import views
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', views.index),
    path('logout', views.logout_view),
    path('login', views.login),
    path('register', views.register),
    path('delete', views.delete),
    path('alimentador', views.crearalimentador),
    path('alimentador/<str:idalim>', views.alimentador),
    path('alimentadores', views.alimentadores),
    path('usuarios', views.usuarios),
    path('flickr/<str:idfoto>', views.foto),
    path('youtube/<str:idvideo>', views.video),
    path('alimentador/<str:iditem>/vote', views.vote),
    path('alimentador/<str:iditem>/comment', views.comment),
    path('darkmode', views.darkmode),
    path('tamletra', views.tamletra),
    path('informacion', views.informacion),
    path('<str:username>', views.loggedIn),
]

final/miscosas/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
# Create your models here.
class Alimentador(models.Model):
    id = models.CharField(max_length=50, primary_key=True)#primary_key=True para poder sustituir el id por defecto
    nombre = models.CharField(max_length=256, null=True)
    enlace = models.CharField(max_length=256, null=True)
    nitems = models.IntegerField(default=0)
    puntuacion = models.IntegerField(default=0)
    selected = models.BooleanField(default = True)
    type = models.CharField(max_length=7, null=True)
    def __str__(self):
        return self.nombre

class Item(models.Model):
    alimentador = models.ForeignKey(Alimentador, on_delete=models.CASCADE)
    iditem = models.CharField(max_length=50, null=True)
    titulo = models.CharField(max_length=256, null=True)
    enlace = models.URLField(max_length=256, null=True)
    descripcion = models.CharField(max_length=256, null=True)
    picture = models.URLField(null=True)
    votpos = models.IntegerField(default=0)
    votneg = models.IntegerField(default=0)
    puntuacion = models.IntegerField(null=True)
    def __str__(self):
        return self.titulo

class Vote(models.Model):
    voto = models.IntegerField(default=0)
    user = models.ForeignKey(User,on_delete=models.CASCADE)
    item = models.ForeignKey(Item,on_delete=models.CASCADE)
    def __str__(self):
        return 'Ha votado ' + self.user.username + ' en el item: ' + self.item.titulo

class Comment(models.Model):
    comment = models.CharField(max_length=250, null = True)
    user = models.ForeignKey(User,on_delete=models.CASCADE)
    item = models.ForeignKey(Item,on_delete=models.CASCADE)
    title = models.CharField(max_length = 50, null = True)
    date = models.DateTimeField(default=timezone.now)
    fotourl = models.URLField(null=True)
    def __str__(self):
        return 'Ha comentado ' + self.user.username + ' en el item: ' + self.item.titulo + ': ' + self.comment

class UserProfile(models.Model):
    user = models.ForeignKey(User,on_delete=models.CASCADE)
    foto = models.ImageField(upload_to = '', default = 'default.jpg')
    darkmode = models.BooleanField(default = False)
    tamanholetra = models.CharField(max_length=10, null=True)
    def __str__(self):
        return self.user.username

final/miscosas/forms.py
from django import forms
from .models import UserProfile

class UploadImageForm(forms.ModelForm):

    class Meta:
        model = UserProfile
        fields = ('foto',)

final/miscosas/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.http import HttpResponse
from django.contrib.auth import logout
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.contrib.auth import authenticate
from django.contrib.auth import login as do_login
from django.template.loader import get_template
from django.core import serializers
from django.template import RequestContext
import urllib.request
from .models import Alimentador, Item, Vote, Comment, UserProfile, User
from .ytparser import YTChannel
from .flickrparser import FlickerTag
from .forms import UploadImageForm

# Create your views here.
def login(request):
    user = request.user
    usuarios = UserProfile.objects.all()
    try:
        imagen = UserProfile.objects.get(user = user)
        usuario = UserProfile.objects.get(user = user)
        estilousuario = UserProfile.objects.get(user = request.user)
    except:
        imagen = UserProfile.objects.none()
        usuario = UserProfile.objects.none()
        estilousuario = UserProfile.objects.none()
    # Creamos el formulario de autenticación vacío
    form = AuthenticationForm()
    if request.method == "POST":
        # Añadimos los datos recibidos al formulario
        form = AuthenticationForm(data=request.POST)
        # Si el formulario es válido...
        if form.is_valid():
            # Recuperamos las credenciales validadas
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']

            # Verificamos las credenciales del usuario
            user = authenticate(username=username, password=password)

            # Si existe un usuario con ese nombre y contraseña
            if user is not None:
                # Hacemos el login manualmente
                do_login(request, user)
                # Y le redireccionamos a la portada
                url = '/' + user.username
                return redirect(url)
    context = {'form': form, 'imagen': imagen, 'usuarios': usuarios, 'usuario': usuario, 'estilousuario': estilousuario}
    return render(request, "miscosas/index.html", context)

def contextos(request):
    form = AuthenticationForm()
    alimentadores = Alimentador.objects.all()
    usuarios = UserProfile.objects.all()
    topitems = Item.objects.order_by('-puntuacion')[:10]

    try:
        user = request.user
        votos = Vote.objects.filter(user = user)
        uservotes = Vote.objects.filter(user = user)
        imagen = UserProfile.objects.get(user = user)
        usuario = UserProfile.objects.get(user = user)
        useritems = Vote.objects.filter(user = user)[:5]
        estilousuario = UserProfile.objects.get(user = user)
    except:
        votos = Vote.objects.none()
        uservotes = Vote.objects.none()
        imagen = UserProfile.objects.none()
        usuario = UserProfile.objects.none()
        useritems = Vote.objects.none()
        estilousuario = UserProfile.objects.none()

    votelist = []
    for item in uservotes:
        votelist.append(item.item)

    context = {'form': form, 'alimentadores': alimentadores, 'usuarios': usuarios,
    'topitems': topitems, 'votos': votos, 'votelist': votelist, 'imagen': imagen,
    'usuario': usuario,  'useritems': useritems, 'estilousuario': estilousuario}

    return context

def indexxml(user):
    template = get_template("miscosas/index.xml")
    alimentadores = Alimentador.objects.filter(selected=True)
    items = Item.objects.order_by('-puntuacion')[:10]
    c = RequestContext(user, {"alimentadores" : alimentadores, "items" : items}).flatten()
    if user.is_authenticated:
        lastvoted = Vote.objects.filter(user=user)[:5]
        c = RequestContext(user, {"user": user, "alimentadores": alimentadores, "items": items, "voteditems": lastvoted}).flatten()
    respuesta = template.render(c)
    return HttpResponse(respuesta, status=200, content_type="application/xml")

def indexjson(user):
    all = [*Alimentador.objects.filter(selected=True), *Item.objects.order_by('-puntuacion')[:10]]
    json = serializers.serialize('json', all)
    if user.is_authenticated:
        all = [*Alimentador.objects.filter(selected=True), *Item.objects.order_by('-puntuacion')[:10], *Vote.objects.filter(user=user)[:5]]
        json = serializers.serialize('json', all)
    return json

def index(request):
    context1 = contextos(request)
    if request.method == "GET":
        formato = request.GET.get('format')
        if formato:
            if formato == 'xml':
                return HttpResponse(indexxml(request.user), status=200, content_type="application/xml")
            else:
                return HttpResponse(indexjson(request.user), status=200, content_type="application/json")

    context = {'page': 'Inicio'}
    context.update(context1)
    return render(request, "miscosas/format.html", context)

def parse(request, id, alim):
    if alim == 'yt':
        if id != '':
                xml = "https://www.youtube.com/feeds/videos.xml?channel_id=" + id
                xmlStream = urllib.request.urlopen(xml)
                channel = YTChannel(xmlStream)
    elif alim == 'flickr':
        if id != '':
                xml = "https://www.flickr.com/services/feeds/photos_public.gne?tags=" + id
                xmlStream = urllib.request.urlopen(xml)
                channel = FlickerTag(xmlStream)

def alimentadores(request):
    context1 = contextos(request)
    context = {'page': 'Alimentadores'}
    context.update(context1)
    return render(request, "miscosas/alimentadores.html", context)

def crearalimentador(request):
    if request.method == 'POST':
        id = request.POST['id']
        action = request.POST['Alimentador']
        try:
            parsertype = request.POST['parsertype']
        except:
            parsertype = ''

        if action == 'Canal':
            parse(request, id, 'yt')
        elif action == 'Etiqueta':
            parse(request, id, 'flickr')
        elif action == 'Elegir':
            if parsertype == 'youtube':
                parse(request, id, 'yt')
            elif parsertype == 'flickr':
                parse(request, id, 'flickr')

        alimentador = Alimentador.objects.get(id=id)
        alimentador.selected = True
        alimentador.save()

    url = '/alimentador/' + alimentador.id
    return redirect(url)

def alimentador(request, idalim):
    context1 = contextos(request)
    if request.method == 'POST':
        id = request.POST['id']
        alimentador = Alimentador.objects.get(id=id)
        alimentador.selected = True
        alimentador.save()
    alimentador = Alimentador.objects.get(id=idalim)
    items = Item.objects.filter(alimentador = alimentador)
    context = {'alimentador': alimentador, 'items': items}
    context.update(context1)
    return render(request, "miscosas/alim.html", context)

def delete(request):
    if request.method == 'POST':
        id = request.POST['id']
        alimentador = Alimentador.objects.get(id=id)
        alimentador.selected = False
        alimentador.save()

        return redirect('/alimentadores')

def video(request, idvideo):
    user = request.user
    item = Item.objects.get(iditem = idvideo)
    context1 = contextos(request)
    try:
        voto = Vote.objects.filter(user = user).get(item = item)
    except:
        voto = Vote.objects.none()
    video = get_object_or_404(Item, iditem = idvideo)
    comments = Comment.objects.filter(item = video)
    vidempotrado = "https://www.youtube.com/embed/" + idvideo

    context = {'voto': voto, 'video': video, 'comments': comments,
                                        'vidempotrado': vidempotrado}
    context.update(context1)
    return render(request, 'miscosas/video.html', context)

def foto(request, idfoto):
    user = request.user
    item = Item.objects.get(iditem = idfoto)
    context1 = contextos(request)
    try:
        voto = Vote.objects.filter(user = user).get(item = item)
    except:
        voto = Vote.objects.none()
    foto = get_object_or_404(Item, iditem = idfoto)
    comments = Comment.objects.filter(item = foto)
    context = {'voto': voto, 'foto': foto, 'comments': comments}
    context.update(context1)
    return render(request, 'miscosas/foto.html', context)

def vote(request, iditem):
    if request.method == 'POST':
        item = Item.objects.get(iditem = iditem)
        vote = request.POST['vote']
        user = request.user

        try:
            votoant = Vote.objects.filter(user = user).get(item = item)
            if votoant.voto == 1 and vote == 'dislike':
                item.votpos = item.votpos -1
                item.votneg = item.votneg + 1
                item.puntuacion = item.votpos - item.votneg
                item.save()
                votoant.voto = -1
                votoant.save()
                item.alimentador.puntuacion = item.alimentador.puntuacion - 2
                item.alimentador.save()
            if votoant.voto == -1 and vote == 'like':
                item.votneg = item.votneg -1
                item.votpos = item.votpos + 1
                item.puntuacion = item.votpos - item.votneg
                item.save()
                votoant.voto = 1
                votoant.save()
                item.alimentador.puntuacion = item.alimentador.puntuacion + 2
                item.alimentador.save()
            if item.descripcion:
                url = '/youtube/' + iditem
            elif item.picture:
                url = '/flickr/' + iditem
            return redirect(url)

        except:
            if vote == 'like':
                item.votpos = item.votpos + 1
                item.puntuacion = item.votpos - item.votneg
                item.save()
                voted = Vote(user = user, item = item, voto = 1)
                voted.save()
                item.alimentador.puntuacion = item.alimentador.puntuacion + 1
                item.alimentador.save()
            else:

final/templates/miscosas/alim.html
{% extends 'miscosas/index.html' %}

{% block alim %}
  <ul>
    <h1>{{ alimentador.nombre }}</h1>
    Link: <a href='{{ alimentador.enlace }}'>{{ alimentador.enlace }}</a>
    <br>Numero de items: {{ alimentador.nitems }}
    <br>Puntuacion: {{ alimentador.puntuacion }}
    <form method="POST" action="/alimentador">
     {% csrf_token %}
     <input type="hidden" name="id" value = "{{ alimentador.id }}">
     {% if not alimentador.selected %}
      {% if alimentador.type == 'youtube' %}
       <input type="hidden" name="parsertype" value = "youtube">
      {% elif alimentador.type == 'flickr' %}
       <input type="hidden" name="parsertype" value = "flickr">
      {% endif %}
      <input type="submit" name="Alimentador" value="Elegir" style="text-align: center">
     {% endif %}
    </form>
    <form method="POST" action="/delete">
     {% csrf_token %}
     <input type="hidden" name="id" value = "{{ alimentador.id }}">
     {% if alimentador.selected %}
      <input type="submit" name="Alimentador" value="Borrar" style="text-align: center">
     {% endif %}
    </form>
     {% for item in items %}
     <li>Titulo:
      {% if item.descripcion %}
       <a href="/youtube/{{ item.iditem }}">{{ item }}</a>
      {% elif item.picture %}
       <a href="/flickr/{{ item.iditem }}">{{ item }}</a>
      {% endif %}
     <br>Link: <a href='{{ item.enlace }}'>{{ item.enlace }}</a>
     </li>
    {% endfor %}
  </ul>
 {% endblock %}

final/templates/miscosas/alimentadores.html
{% extends 'miscosas/index.html' %}

{% block alimentadores %}
 <h2>Lista de todos los Alimentadores</h2>
 <br>
 <ul>
 {% for alim in alimentadores %}
  <li>{{ alim.nombre }}
  <br>Link: <a href='/alimentador/{{ alim.id }}'>{{ alim }}</a>
  <br>Numero de items: {{ alim.nitems }}
  <br>Puntuacion: {{ alim.puntuacion }}
  </li>
 {% endfor %}
{% endblock %}

final/templates/miscosas/format.html
{% extends 'miscosas/index.html' %}

{% block format %}
 <b>Mostrar como: </b>
 <form action="" method='GET'>
  <input type='submit' name='format' value='xml'>
 </form>
 <form action="" method='GET'>
  <input type='submit' name='format' value='json'>
 </form>

{% endblock %}

final/templates/miscosas/foto.html
{% extends 'miscosas/index.html' %}

{% block item %}
  <ul>
    <h1>{{ foto.titulo }}</h1>
    <h5>Nombre de la Etiqueta: {{ foto.alimentador.nombre }}</h5>
    <br>
    <img src="{{ foto.picture }}" style="width: 600px;">
    {% if user.is_authenticated %}
     <form method="POST" action="/alimentador/{{ foto.iditem }}/vote">
      {% csrf_token %}
      {% if voto.voto == 1 %}
       <td><input type="submit" name="vote" value="like" id = 'like' disabled=True></td>
      {% else %}
       <td><input type="submit" name="vote" value="like"></td>
      {% endif %}
      {% if voto.voto == -1 %}
       <td ><input type="submit" name="vote" value="dislike" id = 'dislike' disabled=True></td>
      {% else %}
       <td><input type="submit" name="vote" value="dislike"></td>
      {% endif %}
     </form>
     <br>
     <h3>Comenta</h3>
     <form method="POST" action="/alimentador/{{ foto.iditem }}/comment">
     {% csrf_token %}
     <p>Titulo del comentario</p>
      <td><input type="text" name="Title" value="{{ form.title }}" required=True></td>
      <br>
      <p>Cuerpo del comentario</p>
      <td><input type="text" name="Comment" value="{{ form.comment }}" required=True></td>
      <p>Agregar foto al comentario mediante url</p>
      <td><input type="text" name="Foto" value="{{ form.foto }}"></td>
      <button type="submit" name="id" >Comentar</button>
     </form>
    {% endif %}
    <br>
    Link: <a href='{{ foto.enlace }}'>{{ foto.enlace }}</a><br>
    Link etiqueta: <a href='{{ foto.alimentador.enlace }}'>{{ foto.alimentador.enlace }}</a><br>
    Link alimentador: <a href='/alimentador/{{ foto.alimentador.id }}'>{{ foto.alimentador.nombre }}</a><br>
    
    {% if comments %}
     <h2>Comentarios</h2>
     {% for comment in comments %}
      <li> {{comment.user}}: {{comment.title}}
       <br>
       {{comment.comment}}
       <br>
       {% if comment.fotourl%}
        <img src="{{comment.fotourl}}" style="width:100px;height:80px">
        <br>
       {% endif %}
       Fecha: {{comment.date}}
      </li>
     {% endfor %}
    {% endif %}
  </ul>
 {% endblock %}

final/templates/miscosas/index.html
<!doctype html>
{% load static %}
<html lang="es">
 <head>
  <meta charset="utf-8">
  <link rel="icon" type="image/png" href="https://image.flaticon.com/icons/png/128/2092/2092819.png">
  <link rel="stylesheet" href="/static/miscosas/bootstrap.min.css" type="text/css">
  <link rel="stylesheet" href="/static/miscosas/main.css" type="text/css">
  {% if estilousuario.darkmode and user.is_authenticated %}
   <link rel="stylesheet" href="/static/miscosas/oscuro.css" type="text/css">
  {% endif %}
  {% if estilousuario.tamanholetra == 'Pequeño' and user.is_authenticated %}
   <link rel="stylesheet" href="/static/miscosas/pequeño.css" type="text/css">
  {% endif %}
  {% if estilousuario.tamanholetra == 'Grande' and user.is_authenticated %}
   <link rel="stylesheet" href="/static/miscosas/grande.css" type="text/css">
  {% endif %}
  <title>Mis Cosas</title>
 </head>
 <body>
  <div id="titulo">
   <div class='row'>
    <div class='column'><img src="https://image.flaticon.com/icons/png/128/2092/2092819.png"></div>
    <div class='column'><h1>MIS COSAS</h1></div>
    <div class='column' id=login>
     {% if not user.is_authenticated %}
     <form method="POST" action="/login">
     {% csrf_token %}
     {{ form.as_p }}
     <input type="submit" value="Iniciar sesión"/>
     </form>
     {% else %}
     <h4>Has iniciado sesión como:  {{ user.username }}
     <img src = "{{ imagen.foto.url }}" alt = "foto de perfil" style="width:100px;height:80px";></h4>
     <a href="/logout">Cerrar sesión</a>
     {% endif %}
    </div>
   </div>
  </div>
  <div id="navegador">
   <ul>
    {% if page != 'Inicio' %}
     <li><a href="/">Inicio</a></li>
    {% endif %}
    {% if user.is_authenticated %}
     {% if page != 'Mi Perfil' %}
      <li><a href="/{{ user.username }}">Mi Perfil</a></li>
     {% endif %}
    {% else %}
     {% if page != 'Registrate' %}
      <li><a href="/register">Regístrate</a></li>
     {% endif %}
    {% endif %}
    {% if page != 'Usuarios' %}
     <li><a href="/usuarios">Usuarios</a></li>
    {% endif %}
    {% if page != 'Alimentadores' %}
     <li><a href="/alimentadores">Alimentadores</a></li>
    {% endif %}
    {% if page != 'Informacion' %}
     <li><a href="/informacion">Información</a></li>
    {% endif %}
   </ul>
  </div>
  <div class='row'>
  <div class='column'>
  <div id="formalim" >
   <form method="POST" action="/alimentador">
   {% csrf_token %}
    <table>
     <tr>
      <td>ID del canal de YouTube</td>
      <td><input type="text" name="id" required=True style="width: 200px;"></td>
     </tr>
    </table>
    <input type="submit" name="Alimentador" value="Canal">
   </form>
   <form method="POST" action="/alimentador">
   {% csrf_token %}
    <table>
     <tr>
      <td>ID de la etiqueta de Flickr</td>
      <td><input type="text" name="id" required=True style="width: 200px;"></td>
     </tr>
    </table>
    <input type="submit" name="Alimentador" value="Etiqueta">
   </form>
  </div>
  <div id="format">
   {% block format %}
   {% endblock %}
  </div>
  <div id="listaalim">
   <h2>Lista de Alimentadores</h2>
   <br>
   <ul>
   {% for alim in alimentadores %}
    {% if alim.selected %}
     <li>{{ alim.nombre }}
     <br>Link: <a href='{{ alim.enlace }}'>{{ alim }}</a>
     <br>Numero de items: {{ alim.nitems }}
     <br>Puntuacion: {{ alim.puntuacion }}
     <form method="POST" action="/alimentador">
      {% csrf_token %}
      <input type="hidden" name="id" value = "{{ alim.id }}">
      {% if alim.type == 'youtube' %}
       <input type="hidden" name="parsertype" value = "youtube">
      {% elif alim.type == 'flickr' %}
       <input type="hidden" name="parsertype" value = "flickr">
      {% endif %}
      <input type="submit" name="Alimentador" value="Elegir">
     </form>
     <form method="POST" action="/delete">
      {% csrf_token %}
      <input type="hidden" name="id" value = "{{ alim.id }}">
      <input type="submit" name="Alimentador" value="Borrar">
     </form>
     </li>
    {% endif %}
   {% endfor %}
   </ul>
  </div>
  </div>
  <div class='column'>
   <div id="alimentadores">
    {% block alimentadores %}
    {% endblock %}
   </div>
   <div id="register">
    {% block register %}
    {% endblock %}
   </div>
   <div id="user">
    {% block user %}
    {% endblock %}
   </div>
   <div id="item">
    {% block item %}
    {% endblock %}
   </div>
   <div id="alim">
    {% block alim %}
    {% endblock %}
   </div>
   <div id="info">
    {% block info %}
    {% endblock %}
   </div>
  </div>
  <div class='column'>
   <div id="item">
    {% if user.is_authenticated %}
     <h2 style="text-align: center;">Últimos 5 items  votados por el usuario</h2>
     <br>
     <ul>
     {% for item in useritems %}
      {{ item.item.titulo }}
      <br>Link:
      {% if item.item.descripcion %}
       <a href="/youtube/{{ item.item.iditem }}">{{ item.item }}</a>
      {% elif item.item.picture %}
       <a href="/flickr/{{ item.item.iditem }}">{{ item.item }}</a>
      {% endif %}
      <br>Votos Positivos: {{ item.item.votpos }}
      <br>Votos Negativos: {{ item.item.votneg }}
      <br>
      <form method="POST" action="/alimentador/{{ item.item.iditem }}/vote">
      {% csrf_token %}
      {% if item.voto == 1 %}
       <td><input type="submit" name="vote" value="like" id = 'like' disabled=True></td>
      {% else %}
       <td><input type="submit" name="vote" value="like"></td>
      {% endif %}
      {% if item.voto == -1 %}
       <td ><input type="submit" name="vote" value="dislike" id = 'dislike' disabled=True></td>
      {% else %}
       <td><input type="submit" name="vote" value="dislike"></td>
      {% endif %}
      </form>
      <br>
     {% endfor %}
    {% endif %}
   </div>
   <div id="item">
    <h2 style="text-align: center;">Top 10 Items</h2>
    <br>
    <ul>
    {% for item in topitems %}
     {{ item.titulo }}
     <br>Link:
     {% if item.descripcion %}
      <a href="/youtube/{{ item.iditem }}">{{ item }}</a>
     {% elif item.picture %}
      <a href="/flickr/{{ item.iditem }}">{{ item }}</a>
     {% endif %}
     <br>Votos Positivos: {{ item.votpos }}
     <br>Votos Negativos: {{ item.votneg }}
     <br>
     {% if user.is_authenticated %}
      <form method="POST" action="/alimentador/{{ item.iditem }}/vote">
      {% csrf_token %}
      {% if item in votelist %}
       {% for voto in votos %}
        {% if item == voto.item %}
         {% if voto.voto == 1 %}
          <td><input type="submit" name="vote" value="like" id = 'like' disabled=True></td>
         {% else %}
          <td><input type="submit" name="vote" value="like"></td>
         {% endif %}
         {% if voto.voto == -1 %}
          <td ><input type="submit" name="vote" value="dislike" id = 'dislike' disabled=True></td>
         {% else %}
          <td><input type="submit" name="vote" value="dislike"></td>
         {% endif %}
        {% endif %}
       {% endfor %}
      {% else %}
       <td><input type="submit" name="vote" value="like"></td>
       <td><input type="submit" name="vote" value="dislike"></td>
      {% endif %}
      </form>
     {% endif %}
    {% endfor %}
   </div>
  </div>
  </div>
  <div class='row' id="pie">
   <div class='column'>
   </div>
   <div class='column'>
    Esta aplicación utiliza datos proporcionados por Youtube y Flickr, siendo <a href="https://www.youtube.com/">Youtube</a> y <a href="https://www.flickr.com/">Flickr</a> los sitios desde donde se descarga información
   </div>
  </div>
 </body>
</html>

final/templates/miscosas/info.html
{% extends 'miscosas/index.html' %}

{% block info %}
 Practica realizada por Juan Ignacio Magaz Santiago para la asignatura de Servicios y Aplicaciones Telemáticas del grado de Ingeniería en Tecnologías de la Telecomunicación.
 Esta web recoge datos de Youtube y Flickr para su funcionamiento. Los items recogidos pueden ser votados y comentados. Además, puedes utilizar un usuario propio con el que se añaden algunas funcionalidades.
{% endblock %}

final/templates/miscosas/logged.html
{% extends 'miscosas/index.html' %}
 {% block login %}
  <h4>Logged in as {{ username }} <a href="/logout">Logout</a></h4>
 {% endblock %}

final/templates/miscosas/register.html
{% extends 'miscosas/index.html' %}

{% block register %}
  <h2>Nuevo Usuario</h2>
  <form method="POST">
    {{ registerform.as_p }}
    {% csrf_token %}
    <button type="submit">Register</button>
  </form>
  <hr />
  <a href="/login">Login</a>
 {% endblock %}

final/templates/miscosas/users.html
{% extends 'miscosas/index.html' %}

{% block user %}
 <h2>Lista de usuarios</h2>
 <br>
 {% for usuario in usuarios %}
  <div class='row'>
   <div class='column'>
    <img src = "{{ usuario.foto.url }}" alt = "foto de perfil" style="width:100px;height:80px;">
   </div>
   <div class='column'>
    <h3>{{ usuario.user.username }}</h3>
   </div>
  </div>
  <p>Numero de Items votados: {{ usuario.user.vote_set.count }}<p>
  <p>Numero de Items comentados: {{ usuario.user.comment_set.count }}<p>
  <p>Link de la página de usuario: <a href="/{{ usuario.user.username }}">{{ usuario.user.username }}</a></p>
  <br>
 {% endfor %}
{% endblock %}